#pragma once

#include "bullyparams.h"
#include <string>
#include <map>

namespace Bully {

class Buffer;
class BufferManager;
class ModulePreprocess;
class ModuleTrack;
class ModuleAnalyze;

class System {
public:
	static const char * version(){ return "01-06-2006"; }
	System();
	virtual ~System();

	void init( int w, int h, unsigned char* refFrame );

	unsigned char * output();
	void handleInput( bool down, char ascii );
	void handleInput( bool down, int button, int x, int y );
	void createModules();
	void destroyModules();
	void printModules();
	Buffer* getBuffer(const char*);

	Params params;

	struct Alarm {
		Rect<int> area;
		std::string desc;
		Alarm(Rect<int> a, std::string d) : area(a), desc(d) {}
	};
	struct Assessment {
		std::vector<Alarm> alarms;
	};
	Assessment assessSituation( unsigned char* frame );

protected:
	void init();
	void destroy();
	void checkParams();

	BufferManager *buffer;
	std::map<std::string,ModulePreprocess*> modPreprocess;
	std::map<std::string,ModuleTrack*> modTrack;
	std::map<std::string,ModuleAnalyze*> modAnalyze;
};

} // namespace Bully
