#pragma once

#include "bullyobservation.h"
#include "bullytypes.h"
#include "bullycontour.h"

namespace Bully {

class Object;

class Blob : public Observation {
public:
	Blob();
	Blob(Blob const & b);
	virtual ~Blob();
	const Blob& operator= ( const Blob & b );

	int area;
	Rect<int> bbox;
	Vector2<int> centroid;
	std::vector<double> hist;
	Contour contour;

	// Information used in tracking:
	bool entered;
	bool merged;
	Object* obj;

	// Drawing.
	Color col;

private:
	void init( Blob const & b );
};

}; // namespace Bully
