#include "bullymodule.h"
#include "bullybuffermanager.h"
#include "bullyparams.h"

namespace Bully {

Module::Module()
	: buffer(0), params(0), _frameCount(0)
{
	memset(keyPressed, 0, KEY_COUNT*sizeof(bool));
	memset(mousePressed, 0, MOUSEBUTTON_COUNT*sizeof(bool));
}
Module::Module(BufferManager &buffer, Params &params){
	this->buffer = &buffer;
	this->params = &params;
	_frameCount = 0;
	memset(keyPressed, 0, KEY_COUNT*sizeof(bool));
	memset(mousePressed, 0, MOUSEBUTTON_COUNT*sizeof(bool));
}
Module::~Module(){
}
void Module::updateInput(bool down, char ascii){
	keyPressed[ascii] = down;
}
void Module::updateInput(bool down, int mbutton, int x, int y){
	mousePressed[mbutton] = down;
}

} // namespace Bully
