#pragma once

namespace Bully {

class BufferManager;
class Params;

class Module {
public:
	Module();
	Module(BufferManager &buffer, Params &params);
	virtual ~Module();

	virtual void handleInput( bool down, char ascii ) = 0;
	virtual void handleInput( bool down, int mbutton, int x, int y ) = 0;
	void updateInput(bool down, char ascii);
	void updateInput(bool down, int mbutton, int x, int y);

	__int64 frameCount(){ return _frameCount; }

protected:
	BufferManager *buffer;
	Params *params;
	__int64 _frameCount;

	static const int KEY_COUNT = 256;
	static const int MOUSEBUTTON_COUNT = 10;
	static const int MOUSEBUTTON_LEFT = 1;
	static const int MOUSEBUTTON_MIDDLE = 2;
	static const int MOUSEBUTTON_RIGHT = 3;

	bool keyPressed[KEY_COUNT];
	bool mousePressed[MOUSEBUTTON_COUNT];
};

}
