#include "bullymoduleanal.h"
#include "bullybuffer.h"
#include "bullybuffermanager.h"
#include "bullyparams.h"
#include <string>
using namespace std;

namespace Bully {

ModuleAnalyze::ModuleAnalyze()
	: Module()
{
}
ModuleAnalyze::ModuleAnalyze(BufferManager &buffer, Params &params)
	: Module(buffer, params)
{
}
ModuleAnalyze::~ModuleAnalyze(){
}
void ModuleAnalyze::drawDebugOutput(Result &res){
	if( (int)params->get("drawAlarm") == 1 ){
		for( int i = 0; i < res.alarms.size(); i++ ){
			Recti &a = res.alarms[i].area;
			string &d = res.alarms[i].shortDesc;
			Vector2i &toff = res.alarms[i].txtOffset;
			bool thor = res.alarms[i].txtHorizontal;

			buffer->get("output")->rect(a, 0, 0, 255);

			if( thor ){
				buffer->get("output")->print(a.x+toff.x, a.y+toff.y, d.c_str());
			}else{
				Buffer *buf = buffer->get("output");
				int x = a.x+toff.x;
				int y = a.y+toff.y;
				for( int i = 0; i < d.length(); i++ )
					buf->print(x, y+i*16, d[i]);
			}
		}
	}
}

} // namespace Bully
