#pragma once

#include "bullymodule.h"
#include "bullytypes.h"
#include <string>
#include <vector>

namespace Bully {

class ObjectList;

class ModuleAnalyze : public Module {
public:
	ModuleAnalyze();
	ModuleAnalyze(BufferManager &buffer, Params &params);
	virtual ~ModuleAnalyze();

	struct Alarm {
		Recti area;
		std::string desc;
		std::string shortDesc;
		Vector2i txtOffset;
		bool txtHorizontal;
		Alarm(Recti a, const char *d, const char *sd) : area(a), desc(d), shortDesc(sd), txtHorizontal(true) {}
		Alarm(Recti a, std::string d, const char *sd, Vector2i toff, bool thor) : area(a), desc(d), shortDesc(sd), txtOffset(toff), txtHorizontal(thor) {}
	};
	struct Result {
		std::vector<Alarm> alarms;
	};
	virtual Result process( ObjectList * ) = 0;

protected:
	void drawDebugOutput(Result &res);
};

}
