#pragma once

#include "bullymodulepost.h"
#include "bullytypes.h"

namespace Bully {

class Object;

class ModulePostprocess_Default : public ModulePostprocess {
public:
	ModulePostprocess_Default(BufferManager &buffer, Params &params);
	virtual ~ModulePostprocess_Default();

	void process( ObjectList * );
	void handleInput( bool down, char ascii ){};
	void handleInput( bool down, int mbutton, int x, int y ){};

private:
	void assembleTrajectory( Object *);
	void assembleWorldTrajectory( Object *);

	void calcWorldInfo( Object *);
	Vector2d calcImageFeetPos( Object *, Vector2d &vp );
	Vector2d calcImageHeadPos( Object *, Vector2d &vp );
	Vector3d calcWorldFeetPos( Object *, Matrix3d &H, Vector2d &imageFeetPos );
};

}
