#pragma once

#include "bullymodule.h"
#include "bullytypes.h"

struct _IplConvKernel;

namespace Bully {

class BlobList;
class Blob;

class ModulePreprocess : public Module {
public:
	ModulePreprocess();
	ModulePreprocess(BufferManager &buffer, Params &params);
	virtual ~ModulePreprocess();

	virtual void process() = 0;
	virtual BlobList * getBlobList(){ return blobList; }

protected:
	void removeSmallBlobs(const char *src, const char *dst);
	void pseudoColorBlobs(const char *src, const char *dst, bool allwhite=false);
	void labelBlobs(const char *src, const char *dst);
	Vector2i findCentroid(const char *src, Blob & b);
	bool getneighbor(Vector2i &C, int S, int w, int h, Vector2i &N);
	void traceContour(const char *src, int x, int y, Blob & b);
	void getOuterContour(const char *src, Recti &bbox, unsigned char label);
	void traceOuterContour(const char *src, int x, int y, Blob & b);
	void buildHistograms();
	void renderROIBuffer(const char *dst);
	void drawDebugOutput();

	unsigned char pseudoColors[256][3];
	BlobList *blobList;
	_IplConvKernel* structElement;
};

};
