#pragma once

#include "bullymoduletrack.h"
#include <vector>

namespace Bully {

class Blob;
class Object;
class MatchMat;
class MatchStr;
class ModulePostprocess_Default;

class ModuleTrack_Tdt4725 : public ModuleTrack {
public:
	ModuleTrack_Tdt4725( BufferManager &buffer, Params &params );
	virtual ~ModuleTrack_Tdt4725();

	void process( BlobList * );
	void handleInput( bool down, char ascii ){}
	void handleInput( bool down, int mbutton, int x, int y ){};
	ObjectList * getObjectList(){ return objects; }

protected:
	double getBeforeMergeObjDiff(Blob &b, Object &group, Object &o);
	int getBeforeMergeObj(Blob &b, Object &group, std::vector<Object*> &objsBeforeMerge, std::vector<bool> &objTaken);
	void match( BlobList *blobList, MatchStr & prevS, MatchStr & curS );
	void drawTrajectory_own( Object & obj, unsigned char r=0, unsigned char g=0, unsigned char b=0 );
	void drawTrajectory_mostlikely( Object & obj, unsigned char r=0, unsigned char g=0, unsigned char b=0 );
	void drawTrajectory_all( Object & obj );
	void drawDebugOutput();
	void drawBoxes();
	void drawPredBoxes();

	ObjectList *oldObjects; 
};

}; // namespace Bully
