#include "bullyobjectlist.h"
#include <assert.h>
using namespace std;

Bully::Object* Bully::ObjectList::add( Object & obj ){
	objectList.push_back( obj );
#ifdef OBJECT_DEBUG
	printf( "add(%i) ", count() );
#endif
	return &objectList.back();
}
void Bully::ObjectList::deleteExited(){
	int bc = count();

	list<Object>::iterator it = objectList.begin();
	while( it != objectList.end() ){
		if( it->matchResult == Object::EXIT ){
			std::list<Object>::iterator nextit = it;
			++nextit;

			it->decRefCount();
			objectList.erase(it);
			it = nextit;
		}else{
			++it;
		}
	}

#ifdef OBJECT_DEBUG
	if( bc != count() ) printf( "del(%i) ", count() );
#endif
}
void Bully::ObjectList::deleteUnreferenced(){
	list<Object>::iterator it = objectList.begin();
	while( it != objectList.end() ){
		assert( it->refCount() >= 0 );
		if( it->refCount() == 0 ){
			std::list<Object>::iterator nextit = it;
			++nextit;
			objectList.erase(it);
			it = nextit;
		}else{
			++it;
		}
	}
}
void Bully::ObjectList::resetVisited(){
	for( list<Object>::iterator it = objectList.begin(); it != objectList.end(); it++ )
		it->visited = false;
}
Bully::Object& Bully::ObjectList::get(int i){
	assert(i >= 0 && i < count());
	objit it = objectList.begin();
	for( ; it != objectList.end(); it++, i-- ){
		if( i <= 0 ) break;
	}
	return *it;
}
