#pragma once

#include <string>


namespace Bully {

class Observation {
public:
	virtual ~Observation(){
	}

	inline void id( __int32 newId ){ _id = newId; }
	inline void frameFirstDetected( __int64 newFrame ){ _frameFirstDetected = newFrame; }
	inline void frameName( std::string const & newName ){ _frameName = newName; }
	inline void frameName( const char * newName ){ _frameName = newName; }

	inline __int32 id() const { return _id; }
	inline __int64 frameFirstDetected() const { return _frameFirstDetected; }
	inline std::string const & frameName() const { return _frameName; }

protected:
	Observation(){
		init();
	}
	Observation( Observation const & o ){
		init();
		init(o);
	}
	Observation const & operator=( Observation const & o ){
		if( &o == this ) return *this;
		init(o);
		return *this;
	}
	void init(){
		_id = 0;
		_frameFirstDetected = 0;
	}
	void init( Observation const & o ){
		_id = o.id();
		_frameFirstDetected = o.frameFirstDetected();
		_frameName = o.frameName();
	}

private:
	__int32 _id;
	__int64 _frameFirstDetected;
	std::string _frameName;
};

} // namespace Bully
