#include "bullyworldobjectinfo.h"
#include "FLOAT.H"
#include <vector>
#include <iostream>
using namespace std;

namespace Bully {

void WorldObjectInfo::calcStats( int frameCount ){
	// Find the mean speed, min speed and max speed in the last frameCount frames.
	_meanspeed = .0;
	_minspeed = DBL_MAX;
	_maxspeed = .0;

	vector<WorldObjectFrameInfo>::reverse_iterator it = frameInfo.rbegin() + 1;
	double i = 0;
	for( ; i < frameCount && it != frameInfo.rend(); i++, it++ ){

		Vector3d p1 = (it-1)->worldFeetPos;
		Vector3d p2 = it->worldFeetPos;
		double speed = (p1 - p2).abs();

		_meanspeed += speed;
		if( speed < _minspeed ) _minspeed = speed;
		if( speed > _maxspeed ) _maxspeed = speed;

	}
	if( i > 0 ) _meanspeed /= i;
	else		_meanspeed = .0;
}

}
